/**
 * @author Gabor
 *
 * To change this generated comment edit the template variable "typecomment":
 * Window>Preferences>Java>Templates.
 * To enable and disable the creation of type comments go to
 * Window>Preferences>Java>Code Generation.
 */

public class TVC {

	public Memory		mem;
	public Z80			z80;
	public Log			log;
	public Port			port;
	public Surface 		surface;
	public Keyboard		kbd;
		
	public TVC () {
		
		log		= new Log( this);		
		mem		= new Memory( this);
		port	= new Port( this);
		z80		= new Z80( this);
		surface = new Surface( this);
		kbd		= new Keyboard( this);
		// port.tracePORT = true;
	}
	
	public void initialize() {
		
		log.open();
		surface.initialize();
		mem.initialize();
		port.initialize();
		z80.initialize();
		kbd.initialize();	
	}
	
	public static void main ( String [] argv) {
		
		TVC tvc = new TVC();
		
		tvc.initialize();
		
		tvc.log.write( "Videoton TV-Computer Emulator started.");
		tvc.log.write( "(C) Hoffer Gabor, 2003");
		
		tvc.z80.initZ80();		
		tvc.mem.LoadROM();
		
		tvc.z80.traceCPU = 0;
							
		return;
	}
}
